#!/usr/bin/python

import random
import sys
from pybrain.tools.shortcuts import buildNetwork
from pybrain.optimization import GA
from pybrain.datasets.classification import ClassificationDataSet, SupervisedDataSet

dataset = []
f = open("raw-2days-5min.txt")
rawdata = f.readlines()
f.close()

for line in rawdata:
	line = line.replace("\n","").split("\t")
	dataset.append(float(line[7])/10.0)

testset = SupervisedDataSet(20,1)
for i in range(200):
	testset.addSample(dataset[i:i+20],dataset[i+20])


brains = []
popsize = 1000

for i in range(popsize):
	forebrain = buildNetwork(20,random.randint(10,200),1)
	wrongness = testset.evaluateModuleMSE(forebrain)
	print wrongness
	brains.append([wrongness,forebrain])

brains.sort(key = lambda x: x[0])

while True:
	brains = brains[0:len(brains)*2/5]
	for brain in brains:
		if random.random()*2000 < brains[0]:
			brains.remove(brain)
	while len(brains) < popsize:
		if random.random() < 0.5:
			try:
				index = int(abs(random.gauss(0,len(brains)/2)))
				print "index "+index
				randbrain = brains[index]
				forebrain = randbrain.mutate()
				wrongness = testset.evaluateModuleMSE(forebrain)
				brains.append([wrongness,forebrain])
			except:
				continue
		else:
			forebrain = buildNetwork(20,random.randint(10,200),1)
		wrongness = testset.evaluateModuleMSE(forebrain)
		brains.append([wrongness,forebrain])

	brains.sort(key = lambda x: x[0])
	print brains[0]
	print dataset[10:20],brains[0][1].activate(dataset[0:20]),dataset[20]

