#!/usr/bin/python

import random
import sys
from pybrain.tools.shortcuts import buildNetwork
from pybrain.optimization import GA, HillClimber, StochasticHillClimber
from pybrain.datasets.classification import ClassificationDataSet, SupervisedDataSet
import numpy as np

dataset = []
f = open("raw-2days-5min.txt")
rawdata = f.readlines()
f.close()

rawdataset = []
for line in rawdata:
	line = line.replace("\n","").split("\t")
	rawdataset.append(float(line[7])*10.0)

refindata = []
for i in range(390):
	refindatum = rawdataset[i+1]-rawdataset[i]
	refindata.append(refindatum)

stdev = np.std(refindata)
print stdev

testset = SupervisedDataSet(50,1)
for i in range(300):
	testset.addSample(refindata[i:i+50],refindata[i+50])

brain = buildNetwork(50,2500,600,20,1)

sinusoid = 0.0
tau = 2*np.pi

bestscore = 9999999
bestbrain = brain

while True:
	sinusoid = sinusoid + 0.01
	temp = 1/(5*sinusoid)
	if temp < 0.05:
		sinusoid = 0.01
#	temp = 0.05 + (2*np.cos(tau*sinusoid)**8)
	learner = StochasticHillClimber(testset.evaluateModuleMSE, brain, minimize=True, temperature=temp)
#	learner = HillClimber(testset.evaluateModuleMSE, brain, minimize=True)
	learner.maxEvaluations = 10
	brain,goodness = learner.learn()
	
	if goodness < bestscore:
		bestscore = goodness
		bestbrain = brain

	print 
	print temp,np.sqrt(goodness)/stdev,np.sqrt(bestscore)/stdev
	randint = random.randint(50,300)
	print refindata[randint-10:randint],brain.activate(refindata[randint-50:randint]),refindata[randint]

