#!/usr/bin/python

import random
import sys
from pybrain.tools.shortcuts import buildNetwork
from pybrain.optimization import GA, HillClimber, StochasticHillClimber
from pybrain.datasets.classification import ClassificationDataSet, SupervisedDataSet
import numpy as np

def newBrain():
	return buildNetwork(50,random.randint(300,2000),100,10,1)

wordsFile = open("../langsketches/mthes10/mobypos.txt")
lotsOfWords = wordsFile.read().splitlines()
wordsFile.close()

for l in range(len(lotsOfWords)):
	lotsOfWords[l] = lotsOfWords[l].split("\\")[0]

dataset = []
f = open("raw-July2015+-5min.txt")
rawdata = f.readlines()
f.close()

dataset = []
for line in rawdata:
        line = line.replace("\n","").split("\t")
        dataset.append(float(line[7]))

minds = []
mindlen = 3500
for i in range(0,mindlen):
	print "\t"+str(i)
	minds.append([newBrain(),1.0,0.0,random.choice(lotsOfWords),0])

naiverate = float(dataset[30])
naivehave = 1.0*naiverate

for i in range(30,len(rawdata)-60):
	exchangerate = float(dataset[i])
	date = rawdata[i].split("\t")[0]
	minds.sort(key = lambda x : x[1]+(x[2]/exchangerate),reverse=True)
	minds = minds[:mindlen-50]

	cull = []
	for mind in minds:
		earnings = mind[1]+(mind[2]/exchangerate)
		if earnings < 0.9 or random.random() < 1-earnings:
			cull.append(mind)

	cullcount = len(cull)
	for mind in cull:
		minds.remove(mind)

	averagemonies = 0.0
	for mind in minds:
		averagemonies += mind[1]+mind[2]/exchangerate
	averagemonies /= len(minds)


	while len(minds) < mindlen:
		randvar = random.random()
		newmonies = averagemonies
		if randvar < 0.6:
			while True:
				try:
					choice = minds[abs(int(random.gauss(0,len(minds)/2)))]
					break
				except:
					continue
			newmind = choice[0].copy()
			name = choice[3]
			choiceassets = choice[1] + (choice[2]/exchangerate)
			if randvar < 0.45:
				newmind.mutate()
				name += " / "+random.choice(lotsOfWords)
				newmonies = (choiceassets+averagemonies)/2.0
			else:
				newmonies = min([choiceassets,averagemonies])
		else:
			newmind = newBrain()
			name = random.choice(lotsOfWords)
		minds.append([newmind,newmonies,0.0,name,0])

	print
	print date,i,exchangerate,naivehave/exchangerate
	print "%d ded, the rest have %0.8f each" % (cullcount,averagemonies)
	for m in range(len(minds)):
		mind = minds[m]
		mind[4]+=1
		want = mind[0].activate(dataset[i-30:i+20])[0]
		want = (want+4.0)/8.0
		want = min(max(want,0),1) # 0 < want < 1

		have = mind[1]+(mind[2]/exchangerate)

		#discouragement = 0.00001 *(-np.sin(np.pi*(want+0.5))**20)
		#discouragement = 0.0001 * ((((1.2*want)-0.6)**18)/-0.0001)
		discouragement = 0.0001 * ((((1.2*want)-0.6)**10)/-0.006)
		have += discouragement

		if m < 10:# or random.random() < 0.0005:# or m == len(minds)-1: 
			print "%d %d %s\t%0.2f %0.2f %0.2f %0.8f %f" % (m, mind[4], mind[3], want, mind[1], mind[2]/exchangerate, have, discouragement)

		wantBTC = have*want
		wantUSD = have*(1.0-want)
		mind[1] = wantBTC
		mind[2] = wantUSD*exchangerate

for mind in minds:
	have = mind[1]+(mind[2]/exchangerate)
	mind[1] = have
	mind[2] = 0.0

minds.sort(key = lambda x : x[1],reverse=True)

print minds[0]
print minds[-1]
